/****************************************************************************
**
** @source embdomain.h
**
** Algorithms for handling protein domain data.
** For use with Scop and Cath objects defined in ajdomain.h
** 
** Copyright (c) 2004 Jon Ison (jison@hgmp.mrc.ac.uk) 
** @version 1.0 
** @@
** 
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
** 
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
** 
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the
** Free Software Foundation, Inc., 59 Temple Place - Suite 330,
** Boston, MA  02111-1307, USA.
**
****************************************************************************/

#ifdef __cplusplus
extern "C"
{
#endif

#ifndef embdomain_h
#define embdomain_h





/* ======================================================================= */
/* ========================== Scop object ================================ */
/* ======================================================================= */

/*
** Prototype definitions
*/

AjPStr   embScopToPdbid(const AjPStr scop, AjPStr *pdb);
AjBool   embScopToSp(const AjPStr scop, AjPStr *spr, const AjPList list);
AjBool   embScopToAcc(const AjPStr scop, AjPStr *acc, const AjPList list);

/*
** End of prototype definitions
*/




#endif

#ifdef __cplusplus
}
#endif














